/*****************************************
tiendita_movil_cliente.java
 
Midlet: Imprime una pantalla de bienvenida
luego pregunta nombre, articulo y cantidad
y los envia al servidor (tiendita_movil_servidor)

diciembre 2010 -  Rogelio Ferreira Escutia
****************************************/

import javax.microedition.lcdui.*; 
import javax.microedition.midlet.*; 
import javax.microedition.io.*;
import java.io.*;

public class tiendita_movil_cliente extends MIDlet implements CommandListener {

	private Display pantalla;
	private Graficos presentacion;
	Command salir,siguiente;
	private Form pantalla_captura;
	TextField nombre, articulo, cantidad;
	Command enviar;
	String nombre_enviar, articulo_enviar, cantidad_enviar;
	String url = "http://localhost:37995/tiendita_movil_servidor/recibir.jsp", peticion="";
	private Form pantalla_final;

	public tiendita_movil_cliente() {
		pantalla = Display.getDisplay(this);
		presentacion = new Graficos();
		salir = new Command("Salir",Command.EXIT,1);
		presentacion.addCommand(salir);
		siguiente = new Command( "Siguiente",Command.OK,2 );
		presentacion.addCommand(siguiente);
		presentacion.setCommandListener(this);

		pantalla_captura = new Form("Captura de Datos");
		pantalla_captura.append(new StringItem(null, "Escribe tus datos:"));
		nombre = new TextField( "Nombre:","",25,TextField.ANY);
		pantalla_captura.append(nombre);
		articulo = new TextField( "Articulo:","",25,TextField.ANY);
		pantalla_captura.append(articulo);
		cantidad = new TextField( "Cantidad:","",25,TextField.ANY);
		pantalla_captura.append(cantidad);
		pantalla_captura.addCommand(salir);
		enviar = new Command( "Enviar",Command.OK,2 );
		pantalla_captura.addCommand(enviar);
		pantalla_captura.setCommandListener(this);

		pantalla_final = new Form("Final de Transaccion");
		pantalla_final.append(new StringItem(null, "Los datos han sido enviados!!!"));
		pantalla_final.addCommand(salir);
		pantalla_final.setCommandListener(this);
	} 
  
	public void startApp() {
		pantalla.setCurrent(presentacion);
	} 
  
	public void pauseApp() { } 
  
	public void destroyApp(boolean unconditional) { } 
  
	public void commandAction(Command c, Displayable s) {
		if (c == salir) {
			destroyApp(false);
			notifyDestroyed();
		}
      if( c == siguiente ) {
          pantalla.setCurrent(pantalla_captura);
      }
		if( c == enviar ) {
			nombre_enviar = nombre.getString();
			articulo_enviar = articulo.getString();
			cantidad_enviar = cantidad.getString();
			peticion = url + "?nombre=" + nombre_enviar + "&articulo=" + articulo_enviar + "&cantidad=" + cantidad_enviar;
			System.out.println(peticion);
			Thread hilo =  new Thread() {
				public void run() {
					try { conexion( peticion ); } catch( IOException e ) { }
				}
			};
			hilo.start();
			pantalla.setCurrent(pantalla_final);
		}
	}

    void conexion( String url ) throws IOException {
    	HttpConnection con = null;
    	InputStream is = null;
    	OutputStream os = null;
    	StringBuffer sb = new StringBuffer();
    	TextBox tb = null;
    	try {
    		con = (HttpConnection)Connector.open( url );
    		con.setRequestMethod( HttpConnection.GET);
    		con.setRequestProperty( "IF-Modified-Since","05 Nov 2002 07:17:19 GMT" );
    		con.setRequestProperty( "User-Agent","Profile/MIDP-2.0 Configuration/CLDC-1.0");
    		con.setRequestProperty( "Content-Language","es-ES" );
    		con.setRequestProperty( "Content-Type","application/x-www-form-urlencoded" );
    		os = con.openOutputStream();
    		os.write( ("nombre="+nombre).getBytes() );
    	} finally {
    		if( is!= null ) is.close();
    		if( os != null ) os.close();
    		if( con != null ) con.close();
    	}
    	pantalla.setCurrent( tb );
    }
}

class Graficos extends Canvas {
	public void paint(Graphics g) {
		Image img=null;
		g.setColor(255,255,255);
		g.fillRect (0, 0, getWidth(), getHeight());
		g.setColor(0,0,255);
		Font fuente = Font.getFont (Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, Font.SIZE_LARGE);
		g.setFont(fuente);
		g.drawString("PonyTienda Movil", getWidth()/2, 20,Graphics.BASELINE|Graphics.HCENTER);
		try { img = Image.createImage("/itm.jpg"); } catch (Exception e) { System.err.println("error: " + e); }
		g.drawImage (img, getWidth()/2, 120, Graphics.HCENTER|Graphics.VCENTER);
	}
}
